﻿Option Strict On
Imports System.Xml.Linq
Imports System.Windows.Media.Imaging
Imports System.IO.IsolatedStorage
Imports Microsoft.Xna.Framework.Media
Imports System.IO
'Imports Microsoft.Phone.Tasks
Partial Public Class FacialrecognitionPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Const AppId As String = "取得した認証キー"
    Dim uriString As String
    Dim myLine As Line
    Dim myDoc As XElement
    Dim myIndex As Integer
    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        Dim myParam As IDictionary(Of String, String) = NavigationContext.QueryString

        myIndex = Integer.Parse(myParam("Index"))

        Dim myWebClient As New WebClient

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            If resultArgs.Error Is Nothing = False Then
                                                                MessageBox.Show("XMLファイルが見つかりません")
                                                                Exit Sub
                                                            Else

                                                                If myIndex < 0 Then
                                                                    eyeMaskButton.IsEnabled = False
                                                                    Exit Sub
                                                                Else
                                                                    myDoc = XElement.Parse(resultArgs.Result)
                                                                    Image1.Source = New BitmapImage(New Uri("ユーザの専用サーバのURL/ImageFileUpload/ImageData/" & myDoc.Descendants("fileName")(myIndex).Value, UriKind.Absolute))
                                                                End If


                                                            End If
                                                        End Sub
        myWebClient.DownloadStringAsync(New Uri(String.Format("ユーザの専用サーバのURL/ImageFileUpload/ImageData/ImageInfo.xml?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute))

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub eyeMaskButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles eyeMaskButton.Click
        Dim faceHeight As Integer = 0
        'Dim faceScore As Integer = 0
        Dim left_eyeX As Integer = 0
        Dim left_eyeY As Integer = 0
        Dim right_eyeX As Integer = 0
        Dim right_eyeY As Integer = 0

        Dim myUri As Uri = New Uri("ユーザの専用サーバのURL/ImageFileUpload/ImageData/" & myDoc.Descendants("fileName")(myIndex).Value, UriKind.Absolute)
        Dim imageUri = String.Format("https://kaolabo.com/api/detect?apikey={0}&url={1}", AppId, myUri)


        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(New Uri(imageUri, UriKind.Absolute))
        AddHandler myWebClient.DownloadStringCompleted, Sub(resultdSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim readXmldoc As String = resultArgs.Result


                                                            readXmldoc = readXmldoc.Replace("<results version=" & ChrW(34) & "1.0" & ChrW(34) & " xmlns=" & ChrW(34) & "http://xmlns.kaolabo.com/detect" & ChrW(34) & ">", "<results>")
                                                            'MessageBox.Show(readXmldoc)
                                                            Dim xmldoc As XElement = XElement.Parse(readXmldoc)

                                                            For Each result In From c In xmldoc.Descendants("face") Select c
                                                                faceHeight = CInt(result.Attribute("height").Value)
                                                                left_eyeX = CInt(CInt(result.Element("left-eye").Attribute("x").Value) * 0.7)
                                                                left_eyeY = CInt(CInt(result.Element("left-eye").Attribute("y").Value) * 0.7)
                                                                right_eyeX = CInt(CInt(result.Element("right-eye").Attribute("x").Value) * 0.7)
                                                                right_eyeY = CInt(CInt(result.Element("right-eye").Attribute("y").Value) * 0.7)

                                                                myLine = New Line

                                                                With myLine
                                                                    .X1 = left_eyeX + 15
                                                                    .Y1 = left_eyeY
                                                                    .X2 = right_eyeX - 15
                                                                    .Y2 = right_eyeY
                                                                    .Stroke = New SolidColorBrush(Colors.Red)
                                                                    .StrokeThickness = CDbl(faceHeight / 10)
                                                                End With

                                                                InkPresenter1.Children.Add(myLine)

                                                            Next
                                                        End Sub
        savePicturesHubButton.IsEnabled = True

        Exit Sub
    End Sub


    Private Sub savePicturesHubButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles savePicturesHubButton.Click
        Dim imageFileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"

        Dim myWriteableBitmap As WriteableBitmap
        myWriteableBitmap = New WriteableBitmap(InkPresenter1, Nothing)

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.FileExists(imageFileName) = True Then
            storage.DeleteFile(imageFileName)
        End If
        Using myStream As IsolatedStorageFileStream = storage.CreateFile(imageFileName)
            System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, myStream, 448, 336, 0, 85)
        End Using

        Dim myLibray As New MediaLibrary
        Using Stream As IsolatedStorageFileStream = storage.OpenFile(imageFileName, IO.FileMode.Open, IO.FileAccess.Read)
            myLibray.SavePicture(imageFileName, Stream)
            MessageBox.Show("PicturesHubに保存しました。")
        End Using

        'Dim photoTask As New PhotoChooserTask
        'photoTask.Show()
    End Sub

    Private Sub deleteButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles deleteButton.Click
        Dim kakunin = MessageBox.Show("この画像を削除しますか？", "削除確認", MessageBoxButton.OKCancel)

        Select Case kakunin
            Case MessageBoxResult.OK
               Dim myWebClient As New WebClient
                With myWebClient
                    .Encoding = System.Text.Encoding.UTF8
                    .Headers("content-type") = "application/x-www-form-urlencoded"
                End With

                AddHandler myWebClient.UploadStringCompleted, Sub(resultSender As Object, resultArgs As UploadStringCompletedEventArgs)
                                                                  MessageBox.Show("削除しました")
                                                              End Sub
                myWebClient.UploadStringAsync(New Uri("ユーザの専用サーバのURL/ImageFileUpload/Default2.aspx", UriKind.Absolute), myIndex.ToString)
                NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
            Case Else
                Exit Sub
        End Select

    End Sub
End Class
