﻿Option Strict On
Imports System.Xml.Linq

Public Class ImageInfo
    Property 画像名 As String
End Class

Partial Public Class ImageShowPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        Dim myWebClient As New WebClient

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            If resultArgs.Error Is Nothing = False Then
                                                                MessageBox.Show("XMLファイルが見つかりません")
                                                                Exit Sub
                                                            Else
                                                                Dim myDoc As XElement = XElement.Parse(resultArgs.Result)
                                                                Dim imageList As New List(Of ImageInfo)

                                                                For Each result In From c In myDoc.Descendants("fileName") Select c
                                                                    imageList.Add(New ImageInfo With {.画像名 = "ユーザの専用サーバのURL/ImageFileUpload/ImageData/" & result.Value})
                                                                Next
                                                                ListBox1.ItemsSource = imageList
                                                            End If
                                                        End Sub
        myWebClient.DownloadStringAsync(New Uri(String.Format("ユーザの専用サーバのURL/ImageFileUpload/ImageData/ImageInfo.xml?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute))
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        NavigationService.Navigate(New Uri(String.Format("/FacialrecognitionPage.xaml?Index={0}", ListBox1.SelectedIndex.ToString), UriKind.Relative))
    End Sub
End Class
